{
_________________________________________________________________________________________
|                                                                 											|
|											                                                                  |
|	    	           Universal Dynamic WinProc Interceptor for HiAsm v1.0				        	|
|                                                                 											|
|                                                                       								|
|                  		    S#2 Studio, 2008 : ~Mr.Madguy~			                   	|
|					                                                        						          |
_________________________________________________________________________________________
}
unit WndProcIntercept;

interface

uses Windows;

type

  TWPH=longword;

  TWndProc=function(Wnd:HWND;Msg:UINT;WParam:WPARAM;LParam:LPARAM):LRESULT;stdcall;

  TWndCallback=packed record
    UserData:pointer;
    OldProc:TWndProc;
  end;
  PWndCallback=^TWndCallback;

  TWndProcEx=function(Data:PWndCallback;Wnd:HWND;Msg:UINT;WParam:WPARAM;LParam:LPARAM):LRESULT;stdcall;

function InterceptWndProc(Handle:HWND;NewWndProc:TWndProcEx;UserData:pointer):TWPH;
function DisableWndProc(WndProcHandle:TWPH):boolean;

implementation

type

  TExWndCallback=packed record
    CmdCall:byte;
    AddrCall:longword;
    PopAndJmp:longword;
    AddrJmp:TWndProcEx;
    Handle:HWND;
    OldProtect:longword;
    NewWndProc:TWndProcEx;
    CommonData:TWndCallback;
  end;
  PExWndCallback=^TExWndCallback;

const
  MyWndCallback:TExWndCallback=(CmdCall:$E8;AddrCall:$00;
    PopAndJmp:$0460FF58);

function CallbackStub(Wnd:HWND;Msg:UINT;WParam:WPARAM;LParam:LPARAM):LRESULT;stdcall;
asm
  POP EBP
  LEA EAX,[EAX+20]
  POP EDX
  PUSH EAX
  PUSH EDX
  JMP DWORD PTR [EAX-4]
end;

function InterceptWndProc(Handle:HWND;NewWndProc:TWndProcEx;UserData:pointer):TWPH;
  var Data:PExWndCallback;
begin
  New(Data);
  Data^:=MyWndCallback;
  Data.Handle:=Handle;
  Data.NewWndProc:=NewWndProc;
  Data.CommonData.UserData:=UserData;
  Data.CommonData.OldProc:=TWndProc(GetWindowLong(Handle,GWL_WNDPROC));
  Data.AddrJmp:=@CallbackStub;  SetWindowLong(Handle,GWL_WNDPROC,integer(Data));
  Result:=TWPH(Data);
end;

function DisableWndProc(WndProcHandle:TWPH):boolean;
begin
  with PExWndCallBack(WndProcHandle)^ do begin
    SetWindowLong(Handle,GWL_WNDPROC,integer(@CommonData.OldProc));
  end;
  Dispose(pointer(WndProcHandle));
  Result:=true;
end;

end.
