{
_________________________________________________________________________________________
|                                                                 											|
|											                                                                  |
|	          	                  MinMaxInfo for HiAsm v2.0				                      	|
|											                                                                  |
|											                                                                  |
|		                       S#2 Studio, 2008 : ~Mr.Madguy~	      		             	|
|						                                                                  					|
_________________________________________________________________________________________
}
unit hiMinMaxInfo;

interface

uses Windows,Messages,Kol,Share,Debug, WndProcIntercept;

type
  THIMinMaxInfo = class(TDebug)
   private
    Ready:boolean;
    WndProcHandle:TWPH;
   public
    _prop_MinWidth:integer;
    _prop_MinHeight:integer;
    _prop_MaxWidth:integer;
    _prop_MaxHeight:integer;

    _data_Handle:THI_Event;

    _event_onChange:THI_Event;
    _event_onRemove:THI_Event;
    

    procedure _work_doChange(var _Data:TData; Index:word);
    procedure _work_doRemove(var _Data:TData; Index:word);
    procedure _work_doMinWidth(var _Data:TData; Index:word);
    procedure _work_doMaxWidth(var _Data:TData; Index:word);
    procedure _work_doMinHeight(var _Data:TData; Index:word);
    procedure _work_doMaxHeight(var _Data:TData; Index:word);
  end;

function WndProc(Data:PWndCallback;Window:HWND;Msg:UINT;WP:WPARAM;LP:LPARAM):LRESULT;stdcall;

implementation

function WndProc(Data:PWndCallback;Window:HWND;Msg:UINT;WP:WPARAM;LP:LPARAM):LRESULT;
  var Control:THIMinMaxInfo;
begin
  if Msg=WM_GETMINMAXINFO then begin
    Control:=THIMinMaxInfo(Data.UserData);
    with PMinMaxInfo(LP)^ do begin
      ptMaxSize.X:=Control._prop_MaxWidth;
      ptMaxSize.Y:=Control._prop_MaxHeight;
      ptMaxTrackSize.X:=Control._prop_MaxWidth;
      ptMaxTrackSize.Y:=Control._prop_MaxHeight;
      ptMinTrackSize.X:=Control._prop_MinWidth;
      ptMinTrackSize.Y:=Control._prop_MinHeight;
    end;
    Result:=0;
  end
    else Result:=CallWindowProc(@Data.OldProc,Window,Msg,WP,LP);
end;

procedure THIMinMaxInfo._work_doChange(var _Data:TData; Index:word);
  var Wnd:HWND;
begin
  if Ready then Exit;
  Ready:=true;
  Wnd:=ReadInteger(_Data,_data_Handle,0);
  WndProcHandle:=InterceptWndProc(Wnd,WndProc,pointer(Self));
  _hi_OnEvent(_event_OnChange);
end;

procedure THIMinMaxInfo._work_doRemove(var _Data:TData; Index:word);
begin
  if not Ready then Exit;
  Ready:=false;
  DisableWndProc(WndProcHandle);
  _hi_OnEvent(_event_OnRemove);
end;

procedure THIMinMaxInfo._work_doMinWidth(var _Data:TData; Index:word);
begin
   _prop_MinWidth := ToInteger(_Data);
end;

procedure THIMinMaxInfo._work_doMaxWidth(var _Data:TData; Index:word);
begin
   _prop_MaxWidth := ToInteger(_Data);
end;

procedure THIMinMaxInfo._work_doMinHeight(var _Data:TData; Index:word);
begin
   _prop_MinHeight := ToInteger(_Data);
end;

procedure THIMinMaxInfo._work_doMaxHeight(var _Data:TData; Index:word);
begin
   _prop_MaxHeight := ToInteger(_Data);
end;

end.
